function posObj(%obj)
{
	%name = %obj.getName();
	%obj.setName("PosTemp");
	%t = new Player(temp : PosTemp)
	{
		datablock = PosTemp.getDatablock();
	};
	%pos = vectorAdd(%t.getPosition(),"0 0 2");
	%t.delete();
	%obj.setName(%name);
	return %pos;
}
function getPlayerByName(%name)
{
	for(%i=0;%i<serverconnection.getCount();%i++)
		if(serverconnection.getObject(%i).getClassName() $= "Player" && stripos(getSubStr(serverconnection.getObject(%i).getShapeName(),0,strLen(%name)),%name) != -1)
			return serverconnection.getObject(%i);
	return -1;
}
function getTemp()
{
	for(%i=0;%i<serverconnection.getCount();%i++)
	{
		%obj = serverconnection.getObject(%i);
		if(%obj.getClassName() !$= "FxDTSBrick" || %obj.getGroup().getName() !$= "ServerConnection" || %obj.isPlanted())
			continue;
		else
			return %obj;
	}
	return -1;
}
function temptoPos(%pos,%temp)
{
	if(!isObject(%temp))
		%temp = getTemp();
	if(%temp $= -1)
		return false;
	%dif = vectorSub(%pos,%temp.getPosition());
	//%dif = mAbs(getWord(%dif,0)) SPC mAbs(getWord(%dif,1)) SPC mAbs(getWord(%dif,2));
	%x = getWord(%dif,0) / 0.5 * -1;
	%y = getWord(%dif,1) / 0.5 * -1;
	%z = getWord(%dif,2) / 0.5;
	if(getDirection() == 0)
		commandtoserver('superShiftBrick',%y*-1,%x,%z);
	if(getDirection() == 90)
		commandtoServer('superShiftBrick',%x,%y,%z);
	if(getDirection() == 180)
		commandtoserver('superShiftBrick',%y,%x*-1,%z);
	if(getDirection() == 270)
		commandtoServer('superShiftBrick',%x*-1,%y*-1,%z);
	return true;
}
function getDirection()
{
	%obj = serverconnection.getControlobject();
	%angle = getword(axisToEuler(getWords(%obj.getTransform(),3,6)),2);
	%angle = mFloor(%angle + 0.5);
	if(%angle < 0)
		%angle = %angle + 360;
	return getword(roundAngle(%angle),1);
}
function temptoPlayer(%name,%val)
{
	if(%val $= "")
	{
		cancel($tempBot);
		$TempBot::Player = getPlayerByName(%name);
		if($tempBot::Player $= -1)
		{
			echo("TempBot: Could not find player.");
			return;
		}
		$TempBot::Brick = getTemp();
	}
	if($tempBot::Player $= "" || $TempBot::Player $= -1)
		$TempBot::Player = getPlayerByName(%name);
	if($tempBot::Player $= -1)
	{
		echo("TempBot: Canceled, could not find player.");
		return;
	}
	if(!temptopos(posObj($tempBot::Player,$TempBot::Brick)))
	{
		echo("TempBot: Error has occured.");
		return;
	}
	$tempBot = schedule(200,0,temptoPlayer,"",1);
}
function roundAngle(%angle)
{
	if(%angle == 360)
		return "North 0";
	if(%angle >= 0 && %angle < 45)
		return "North 0";
	if(%angle >= 45 && %angle < 135)
		return "West 90";
	if(%angle >= 135 && %angle < 225)
		return "South 180";
	if(%angle >= 225 && %angle < 315)
		return "East 270";
	if(%angle >= 315 && %angle < 360)
		return "North 0";
	else
		return false;
}
function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}

function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,3) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,0) * %sinThetaOver2;
	%q2 = getWord(%axis,1) * %sinThetaOver2;
	%q3 = getWord(%axis,2) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}
function editBrick(%type)
{
	if(%type $= "music")
		canvas.pushDialog("WrenchSoundDlg");
	else if(%type $= "vehicle")
		canvas.pushDialog("WrenchVehicleSpawnDlg");
	else
		canvas.pushDialog("WrenchDlg");
}